import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';

class GestureDetectorCustomLongTapDuration extends StatelessWidget {
  const GestureDetectorCustomLongTapDuration(
      {Key key,
      this.duration = const Duration(milliseconds: 500),
      this.onLongPress,
      this.onTap,
      this.onCancel,
      this.onTapDown,
      this.onTapUp,
      this.onSecondaryTap,
      this.onSecondaryCancel,
      this.onSecondaryTapDown,
      this.onSecondaryTapUp,
      this.onTertiaryTapCancel,
      this.onTertiaryTapUp,
      this.onTertiaryTapDown,
      this.onLongPressEnd,
      this.onLongPressMoveUpdate,
      this.onLongPressStart,
      this.onLongPressUp,
      this.onSecondaryLongPressEnd,
      this.onSecondaryLongPressMoveUpdate,
      this.onSecondaryLongPressStart,
      this.onSecondaryLongPressUp,
      this.onSecondatyLongPress,
      this.onTertiaryLongPress,
      this.onTertiaryLongPressEnd,
      this.onTertiaryLongPressMoveUpdate,
      this.onTertiaryLongPressStart,
      this.onTertiaryLongPressUp,
      this.child})
      : super(key: key);
  final Duration duration;
  final Function onTap;
  final Function onCancel;
  final Function onTapDown;
  final Function onTapUp;
  final Function onSecondaryTap;
  final Function onSecondaryCancel;
  final Function onSecondaryTapDown;
  final Function onSecondaryTapUp;
  final Function onTertiaryTapCancel;
  final Function onTertiaryTapUp;
  final Function onTertiaryTapDown;
  final Function onLongPress;
  final Function onLongPressEnd;
  final Function onLongPressMoveUpdate;
  final Function onLongPressStart;
  final Function onLongPressUp;
  final Function onSecondatyLongPress;
  final Function onSecondaryLongPressEnd;
  final Function onSecondaryLongPressMoveUpdate;
  final Function onSecondaryLongPressStart;
  final Function onSecondaryLongPressUp;
  final Function onTertiaryLongPress;
  final Function onTertiaryLongPressEnd;
  final Function onTertiaryLongPressStart;
  final Function onTertiaryLongPressMoveUpdate;
  final Function onTertiaryLongPressUp;
  final Widget child; // Child widget of the CustomLongTap
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: RawGestureDetector(
        child: child,
        gestures: {
          TapGestureRecognizer:
              GestureRecognizerFactoryWithHandlers<TapGestureRecognizer>(
            () => TapGestureRecognizer(),
            (TapGestureRecognizer instance) {
              instance..onTap = onTap;
              instance..onTapCancel = onCancel;
              instance..onTapDown = onTapDown;
              instance..onTapUp = onTapUp;
              instance..onSecondaryTap = onSecondaryTap;
              instance..onSecondaryTapCancel = onSecondaryCancel;
              instance..onSecondaryTapDown = onSecondaryTapDown;
              instance..onSecondaryTapUp = onSecondaryTapUp;
              instance..onTertiaryTapCancel = onTertiaryTapCancel;
              instance..onTertiaryTapDown = onTertiaryTapDown;
              instance..onTertiaryTapUp = onTertiaryTapUp;
            },
          ),
          LongPressGestureRecognizer:
              GestureRecognizerFactoryWithHandlers<LongPressGestureRecognizer>(
            () => LongPressGestureRecognizer(duration: duration),
            (LongPressGestureRecognizer instance) {
              instance..onLongPress = onLongPress;
              instance..onLongPressEnd = onLongPressEnd;
              instance..onLongPressMoveUpdate = onLongPressMoveUpdate;
              instance..onLongPressStart = onLongPressStart;
              instance..onLongPressUp = onLongPressUp;
              instance..onSecondaryLongPress = onSecondatyLongPress;
              instance..onSecondaryLongPressEnd = onSecondaryLongPressEnd;
              instance
                ..onSecondaryLongPressMoveUpdate =
                    onSecondaryLongPressMoveUpdate;
              instance..onSecondaryLongPressStart = onSecondaryLongPressStart;
              instance..onSecondaryLongPressUp = onSecondaryLongPressUp;
              instance..onTertiaryLongPress = onTertiaryLongPress;
              instance..onTertiaryLongPressEnd = onTertiaryLongPressEnd;
              instance..onTertiaryLongPressStart = onTertiaryLongPressStart;
              instance
                ..onTertiaryLongPressMoveUpdate = onTertiaryLongPressMoveUpdate;
              instance..onTertiaryLongPressUp = onTertiaryLongPressUp;
            },
          ),
        },
      ),
    );
  }
}
